# This file was automatically generated by Dist::Zilla::Plugin::MakeMaker v5.043.
use strict;
use warnings;

use 5.010001;

use ExtUtils::MakeMaker;

my %WriteMakefileArgs = (
  "ABSTRACT" => "Some utilities related to Perinci",
  "AUTHOR" => "perlancar <perlancar\@cpan.org>",
  "CONFIGURE_REQUIRES" => {
    "ExtUtils::MakeMaker" => 0
  },
  "DISTNAME" => "App-PerinciUtils",
  "EXE_FILES" => [
    "bin/normalize-rinci-function-metadata",
    "bin/peri-access",
    "bin/peri-htserve",
    "bin/peri-run",
    "bin/wrap-with-perinci-sub-wrapper"
  ],
  "LICENSE" => "perl",
  "MIN_PERL_VERSION" => "5.010001",
  "NAME" => "App::PerinciUtils",
  "PREREQ_PM" => {
    "Complete::Module" => 0,
    "Complete::Riap" => 0,
    "Complete::Util" => 0,
    "DBI" => 0,
    "Data::Dump" => 0,
    "Data::Dump::Color" => 0,
    "File::HomeDir" => 0,
    "File::Slurper" => 0,
    "File::Write::Rotate" => "0.29",
    "Gepok" => 0,
    "Getopt::Long::Complete" => 0,
    "JSON::MaybeXS" => 0,
    "Log::Any::IfLOG" => "0.07",
    "Module::List" => 0,
    "Module::Load" => 0,
    "Perinci::Access" => 0,
    "Perinci::Access::Base::Patch::PeriAHS" => 0,
    "Perinci::CmdLine::Any" => 0,
    "Perinci::Gen::ForModule" => 0,
    "Perinci::Sub::Normalize" => "0.18",
    "Perinci::Sub::Wrapper" => "0.78",
    "Plack::Builder" => 0,
    "Plack::Middleware::Auth::Basic" => 0,
    "Plack::Runner" => 0,
    "Starman" => 0,
    "String::LineNumber" => 0,
    "YAML::XS" => 0,
    "lib" => 0,
    "strict" => 0,
    "warnings" => 0
  },
  "TEST_REQUIRES" => {
    "File::Spec" => 0,
    "IO::Handle" => 0,
    "IPC::Open3" => 0,
    "Test::More" => 0
  },
  "VERSION" => "0.09",
  "test" => {
    "TESTS" => "t/*.t"
  }
);


my %FallbackPrereqs = (
  "Complete::Module" => 0,
  "Complete::Riap" => 0,
  "Complete::Util" => 0,
  "DBI" => 0,
  "Data::Dump" => 0,
  "Data::Dump::Color" => 0,
  "File::HomeDir" => 0,
  "File::Slurper" => 0,
  "File::Spec" => 0,
  "File::Write::Rotate" => "0.29",
  "Gepok" => 0,
  "Getopt::Long::Complete" => 0,
  "IO::Handle" => 0,
  "IPC::Open3" => 0,
  "JSON::MaybeXS" => 0,
  "Log::Any::IfLOG" => "0.07",
  "Module::List" => 0,
  "Module::Load" => 0,
  "Perinci::Access" => 0,
  "Perinci::Access::Base::Patch::PeriAHS" => 0,
  "Perinci::CmdLine::Any" => 0,
  "Perinci::Gen::ForModule" => 0,
  "Perinci::Sub::Normalize" => "0.18",
  "Perinci::Sub::Wrapper" => "0.78",
  "Plack::Builder" => 0,
  "Plack::Middleware::Auth::Basic" => 0,
  "Plack::Runner" => 0,
  "Starman" => 0,
  "String::LineNumber" => 0,
  "Test::More" => 0,
  "YAML::XS" => 0,
  "lib" => 0,
  "strict" => 0,
  "warnings" => 0
);


unless ( eval { ExtUtils::MakeMaker->VERSION(6.63_03) } ) {
  delete $WriteMakefileArgs{TEST_REQUIRES};
  delete $WriteMakefileArgs{BUILD_REQUIRES};
  $WriteMakefileArgs{PREREQ_PM} = \%FallbackPrereqs;
}

delete $WriteMakefileArgs{CONFIGURE_REQUIRES}
  unless eval { ExtUtils::MakeMaker->VERSION(6.52) };

WriteMakefile(%WriteMakefileArgs);

# modify generated Makefile to generate shell completion scripts. this piece
# is generated by Dist::Zilla::Plugin::GenShellCompletion version 0.11.
GEN_SHELL_COMPLETION:
{
    last unless grep { $^O eq $_ } ("aix","beos","cygwin","darwin","dragonfly","freebsd","gnukfreebsd","haiku","hpux","interix","irix","linux","midnightbsd","minix","mirbsd","netbsd","openbsd","sco","solaris");

    print "Modifying Makefile to generate shell completion on install\n";
    open my($fh), "<", "Makefile" or die "Can't open generated Makefile: $!";
    my $content = do { local $/; ~~<$fh> };

    $content =~ s/^(install :: pure_install doc_install)/$1 comp_install/m
        or die "Can't find pattern in Makefile (1)";

    $content =~ s/^(uninstall :: .+)/$1 comp_uninstall/m
        or die "Can't find pattern in Makefile (2)";

    $content .= qq|\ncomp_install :\n\t| .
        q|$(PERLRUN) -E'if(eval { require App::shcompgen; 1 }) { system "shcompgen", "--verbose", "generate", "--replace", ($$App::shcompgen::VERSION >= 0.15 ? ("--remove"):()), @ARGV }' -- $(EXE_FILES)| .
        qq|\n\n|;

    $content .= qq|\ncomp_uninstall :\n\t| .
        q|$(PERLRUN) -E'if(eval { require App::shcompgen; 1 }) { system "shcompgen", "--verbose", "remove", @ARGV }' -- $(EXE_FILES)| .
        qq|\n\n|;

    open $fh, ">", "Makefile" or die "Can't write modified Makefile: $!";
    print $fh $content;
}
